﻿using System.Reflection;
using HarmonyLib;
using UnityEngine;

public class RecycleYourMetal : Mod
{
    private const string logPrefix = "[<color=#0000ff>Recycle Your Metal</color>] ";
    private Harmony harmonyInstance;
    private string harmonyId = "com.nundir.recycleyourmetal";

    public void Start()
    {
        harmonyInstance = new Harmony(harmonyId);
        harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());

        Debug.Log(logPrefix + "RecycleYourMetal loaded!");
    }

    public void OnModUnload()
    {
        harmonyInstance.UnpatchAll(harmonyId);
        Debug.Log(logPrefix + "RecycleYourMetal unloaded!");
    }
}

[HarmonyPatch(typeof(Block_CookingStand)), HarmonyPatch("GetCookingSlotsForItem")]
internal class GetCookingSlotsForItemSmelterPatch
{
    private static void Prefix(ref Item_Base itemToInsert)
    {
        if (itemToInsert.UniqueName == "Bolt" || itemToInsert.UniqueName == "Hinge")
        {
            itemToInsert = ItemManager.GetItemByName("MetalOre");
        }
    }
}

[HarmonyPatch(typeof(Block_CookingStand)), HarmonyPatch("InsertItem")]
internal class InsertItemSmelterPatch
{
    private static void Prefix(ref Item_Base itemToInsert, CookingSlot[] emptySlots)
    {
        if (itemToInsert.UniqueName == "Bolt" || itemToInsert.UniqueName == "Hinge")
        {
            itemToInsert = ItemManager.GetItemByName("MetalOre");
        }
    }
}